'''
Created on 18 nov 2015

@author: erik
'''


import random

def ConvertToPLY(filename):
    import subprocess
    p = subprocess.Popen('meshconv.exe ' + filename + ' -c ply -ascii', stderr=subprocess.STDOUT)
    p.wait()
    return


def rout(filename, scaling):
    import subprocess
    p = subprocess.Popen('bscor_alt.bat ' + filename + ' ' + str(scaling), stderr=subprocess.STDOUT)
    p.wait()
    return


def ReadPly(filename):
    import re

    x = []
    y = []
    z = []
    internallist = []  # list of internal support
    doublelist = []  # list of double edges

    #     xlinelist=[] #Not currently used!
    #     ylinelist=[]
    #     zlinelist=[]

    faces = []

    with open(filename) as f:
        content = f.read()  # read the ply file as a string

    vertexnr = int(re.findall('vertex\s\d+', content)[0][7:])  # find the number of vertices
    print vertexnr

    facenr = int(re.findall('face\s\d+', content)[0][5:])  # find the number of faces


    content = re.split('\r\n', content)  # split the string into lines



    firstline = content.index('end_header')  # finds the end of the header (the start of the data)

    for n in content[0:firstline]:  # looks for lines describing internal and doubble edges
        if n[0:15] == 'comment support':
            j = re.split('\s', n)
            internallist.append([j[2], j[3]])
            print 'found internal edge'
        if n[0:14] == 'comment double':
            j = re.split('\s', n)
            doublelist.append([j[2], j[3]])
            print 'found double edge'

    for n in content[firstline + 1:firstline + 1 + vertexnr]:  # extract vertex coordinates
        j = re.split('\s', n)
        x.append(float(j[0]))
        y.append(float(j[1]))
        z.append(float(j[2]))

    for n in content[firstline + vertexnr + 1:firstline + 1 + vertexnr + facenr]:  # extract the face descriptions
        j = re.split('\s', n)
        faces.append(j[1:int(j[0]) + 1])  # the first value of the face list contains the expected number of verts

    placeholder = []
    for n in faces:  # extract all the indiviual edges from the faces (this has a lot of duplicates)
        n.append(n[0])  # add the first value to the end to close the circle
        for i in range(len(n) - 1):
            placeholder.append(sorted([n[i], n[i + 1]]))  # the sorting is needed to remove duplicate edges later

    placeholder = sorted(placeholder, key=lambda item: item[0])

    edgelist = []

    for n in placeholder:  # save only one copy of each edge to edgelist
        if n not in edgelist:
            edgelist.append(n)

    #     for n in edgelist:#converts the edges from vertex numbers to coordinates
    #         xlinelist.append([float(x[int(n[0])]),float(x[int(n[1])])])
    #         ylinelist.append([float(y[int(n[0])]),float(y[int(n[1])])])
    #         zlinelist.append([float(z[int(n[0])]),float(z[int(n[1])])])
    #

    dict_of_edge={}
    for couple in edgelist:
            dict_of_edge[len(dict_of_edge) + 1] = couple

    int_list = []
    int_dict = {}


    return (x, y, z, edgelist, faces, doublelist, internallist,dict_of_edge,int_list,int_dict)


def MeshLength(edgelist, x, y, z):
    import math
    TotalLenght = 0.0

    for n in edgelist:
        TotalLenght += math.sqrt((x[int(n[0])] - x[int(n[1])]) ** 2.0 + (y[int(n[0])] - y[int(n[1])]) ** 2.0 + (
                    z[int(n[0])] - z[int(n[1])]) ** 2.0)
    return TotalLenght


def NucleotideUse(length, scalingfactor, vertexnr):
    return int(float(
        length) * scalingfactor * 3.08) - vertexnr * 18  # estimates using the lenght of the mesh and scaling factor and does a "penalty subtraction" for the number of verts. THIS is a rough estimate


def WritePLY(file_path, x, y, z, facelist, double_list, internal_list):
    new_file_path = file_path[:-4] + '.ply'#'MODIFIED.ply'
    f = open(new_file_path, 'w+')
    f.write('ply\nformat ascii 1.0')
    f.write('\nelement vertex ' + str(len(x)))
    f.write('\nproperty float32 x\nproperty float32 y\nproperty float32 z')
    f.write('\nelement face ' + str(len(facelist)))
    for i in internal_list:
        f.write('\nstaple_edge '+ i[0]+' '+ i[1])
    f.write('\nproperty list uint8 int32 vertex_indices')
    for i in internal_list:
        f.write('\ncomment support ' + i[0] + ' ' + i[1])
    for i in double_list:
        f.write('\ncomment double ' + i[0] + ' ' + i[1])
    f.write('\nend_header')
    for i in range(len(x)):
        f.write('\n' + str(x[i]) + ' ' + str(y[i]) + ' ' + str(z[i]))
    for n in facelist:
        f.write('\n' + str(len(n) - 1) + ' ')
        for j in n[:-1]:
            f.write(str(j) + ' ')

    print new_file_path
    return new_file_path


def RemoveDuplicates(list):
    newlist = []

    for n in list:  # save only one copy of each edge to edgelist, also prevents duplicate copies that are "flipped"
        j = [n[1], n[0]]
        if n not in newlist:
            if j not in newlist:
                if n[0] != n[1]:
                    newlist.append(n)

    return newlist


def search_internal2(x, y, z,vertex1,vertex2): #Find the vertixes coordinates in the x,y,z list. then append them to x2,2,z2, the lists for coordinates to sum

    from operator import itemgetter


    global value, x2, y2, z2

    x2 = []
    y2 = []
    z2 = []
    value = True

    vertex1 = int(vertex1)
    vertex2 = int(vertex2)

    try:
        getter = itemgetter(vertex1)
        desidered = getter(x)
        x2.append(desidered)
        getter = itemgetter(vertex2)
        desidered = getter(x)
        x2.append(desidered)

        getter = itemgetter(vertex1)
        desidered = getter(y)
        y2.append(desidered)
        getter = itemgetter(vertex2)
        desidered = getter(y)
        y2.append(desidered)

        getter = itemgetter(vertex1)
        desidered = getter(z)
        z2.append(desidered)
        getter = itemgetter(vertex2)
        desidered = getter(z)
        z2.append(desidered)

    except IndexError:
        msg = "Too high"
        print msg
        value = False

    return x2, y2, z2, value, vertex1, vertex2


def average_vert(x, y, z):  # calculate the average for the new vertex and append them to x,y,z lists
    global x2, y2, z2, value

    if value == False:
        value = True
        pass
    else:
        xm = sum(x2)
        xm = xm / 2.0

        ym = sum(y2)
        ym = ym / 2.0

        zm = sum(z2)
        zm = zm / 2.0

        x.append(xm)
        y.append(ym)
        z.append(zm)

    x2 = []
    y2 = []
    z2 = []

    return x, y, z


def find_faces(faces, x, vertex1, vertex2):  # change the lines of the faces where the new vertex is

    for line in faces:
        if str(vertex1) in line and str(vertex2) in line:
            i1 = [i for i, l in enumerate(line[0:len(line)-1]) if l == str(vertex1)]
            i2 = [i for i, l in enumerate(line[0:len(line)-1]) if l == str(vertex2)]
            i1 = sum(i1)
            i2 = sum(i2)
            if i1 == 0 or i2 == 0:
                if i1 - i2 == 1 or i2 - i1 == 1 or i1 - i2 == -1 or i2 - i1 == -1:
                    line.insert(min(i1, i2) + 1, str(len(x)-1))
                else:
                    line.insert(0, str(len(x)-1))
            else:
                if i1 < i2:
                    line.insert(int(i1) + 1, str(len(x)-1))
                if i1 > i2:
                    line.insert(int(i2) + 1, str(len(x)-1))

    return faces


def new_list(dict_of_edge, int_list,wanted):

    import random
    from compiler.ast import flatten

    new = flatten(int_list)

    no_int = []  # create a new list without the edges already with int edges
    for element in dict_of_edge.keys():
        if element not in new:
            no_int.append(element)

    chosen = random.choice(no_int)  # choose the destination edge

    # print chosen

    vert_couple = dict_of_edge[chosen]  # find the two vertexes to be used to calculate the new vertex
    # print vert_couple
    int_list_1 = []  # new int_list to update the .txt file

    for couple in int_list:
        if wanted not in couple:
            int_list_1.append(couple)
        else:
            couple_1 = []
            for number in couple:
                '''if number != str(wanted):
                    couple_1.append(str(chosen))
                else:
                    couple_1.append(number)'''
                if number == wanted:
                    couple_1.append(chosen)
                else:
                    couple_1.append(number)
            int_list_1.append(couple_1)

    return int_list_1,vert_couple


def create_new(int_list, dict_of_edge, x, y, z, facelist, doublelist, internal_support_list):  # take the empty structure
    # plus a .txt file and create a new structure



    for edge_couple in int_list:
        if edge_couple[0] in dict_of_edge:
            vertices = dict_of_edge.get(edge_couple[0])
            search_internal2(x, y, z, vertices[0], vertices[1])
            average_vert(x, y, z)
            find_faces(facelist, x, vertices[0], vertices[1])
        if edge_couple[1] in dict_of_edge:
            vertices = dict_of_edge.get(edge_couple[1])
            search_internal2(x, y, z, vertices[0], vertices[1])
            average_vert(x, y, z)
            find_faces(facelist, x, vertices[0], vertices[1])
        from_value = str(len(x) - 2)
        to_value = str(len(x) - 1)
        internal_support_list.append([from_value, to_value])
        internal_support_list = RemoveDuplicates(internal_support_list)

    return x, y, z, facelist, doublelist, internal_support_list, int_list


def dist(x, y, z, dict_of_edge, wanted, vert_couple,scaling):
    from scipy.spatial import distance
    import math
    for key, value in dict_of_edge.iteritems():  # assign value to vertex of wanted edge
        if key == wanted:
            vert_1 = value[0]
            vert_2 = value[1]

    # print vert_1,vert_2

    x1,y1,z1=(x[int(vert_2)] + x[int(vert_1)])/2, (y[int(vert_2)] + y[int(vert_1)])/2,(z[int(vert_2)] + z[int(vert_1)])/2

    vert_3=vert_couple[0]
    vert_4=vert_couple[1]

    x2,y2,z2=(x[int(vert_3)] + x[int(vert_4)])/2, (y[int(vert_3)] + y[int(vert_4)])/2,(z[int(vert_3)] + z[int(vert_4)])/2
    # coordinates of the new vertex. ONLY to calculate the distance
    v1=(x1, y1, z1)
    v2=(x2, y2, z2)

    # dst= distance.euclidean(v1,v2)*scaling
    # print dst

    dst = [(a - b) ** 2 for a, b in zip(v1,v2)]
    dst = math.sqrt(sum(dst))*scaling

    return dst


def new_random_structure(filename_in, filename_out, scaling, list_of_internal, edge_to_modify):

    x, y, z, edgelist, facelist, doublelist, internal_support_list, dict_of_edge, int_list, int_dict = ReadPly \
        (filename_in)  # open the basic, empty structure

    x, y, z, facelist, doublelist, internal_support_list, int_list = create_new \
        (list_of_internal,dict_of_edge, x, y, z, facelist, doublelist,
         internal_support_list)  # update the info with the ones created from .txtfile

                             # the edge in the couple to modify


    wanted = list_of_internal[edge_to_modify][random.choice([0,1])] # select what edge to modify by selecting one of the internal edges and then randomly selecting what end of it to modify

    print wanted

    distance = 0

    while distance < 10.0 * scaling or distance > 15.0 * scaling:
        int_list_1, vert_couple = new_list(dict_of_edge, int_list, wanted)  # new int_list


        print int_list_1
        # print str(vert_couple)

        distance = dist(x, y, z, dict_of_edge, wanted, vert_couple, scaling)  # check the distance

        print distance

    file_path = filename_out  # new .txt path
    new_file_path = file_path[:-4] + '_'.join(vert_couple) + ".txt"


    x, y, z, edgelist, facelist, doublelist, internal_support_list, dict_of_edge, int_list, int_dict = ReadPly \
        (filename_in)  # open the basic structure to be used as a model

    x, y, z, facelist, doublelist, internal_support_list, int_list = create_new \
        (int_list_1, dict_of_edge, x, y, z, facelist, doublelist,internal_support_list)  # create the new structure from new .txt

    WritePLY(filename_out, x, y, z, facelist, doublelist,internal_support_list)  # create a new .ply file. Not necessary?

    return int_list_1
