#   ClientMain.py
#       created on: 15 March 2017
#
#           Author: Andreas Gadin

import socket as socket
import time
import os


def retrFilenamesnames(s):
    count = 0

    data = s.recv(1024)
    while 1:
        count += 1
        print(count)
        line = data.split(' ')
        print(line)
        if line[-1] == 'end':
            break
        else:
            data += s.recv(1024)
        time.sleep(0.1)
    print('data', data)
    directory_list = data.rstrip(' end').split(' ')
    print(directory_list)
    s.close()
    return directory_list

#filename should be absolute searchpath
def sendFile(s, filename):
    idx = filename.rfind('/')
    s.send(filename[idx+1:])
    handshake = s.recv(1024)
    filesize = str(os.path.getsize(filename))
    s.send(filesize)
    handshake = s.recv(1024)

    with open(filename, 'rb') as f:
        bytesToSend = f.read()
        s.send(bytesToSend)
        while bytesToSend != '':
            bytesToSend = f.read()
            s.send(bytesToSend)
    s.close()

def retrFile(s):
    path = 'C:/Users/biomatadm.MBB-BM-D-BOXEN/Documents/maya/projects/oxDNAitertest19/scenes/'
    filename = s.recv(1024)
    s.send('handshake')
    print(filename)
    data = s.recv(1024)
    print(data)
    filesize = int(data)
    s.send('handshake')

    filename = filename[filename.rfind('/'):]

    with open(path + '/' + filename, 'wb') as f:
        data = s.recv(1024)
        totalRecv = len(data)
        f.write(data)

        while totalRecv < filesize:
            data = s.recv(1024)
            totalRecv += len(data)
            f.write(data)
    s.close()

def main(number_of_files, directory_list, filename_list, host):
    print('Client started')
    if not host:
        host = socket.gethostname()
    port = 5000
    print('Trying connection ', host)

    # Sends the number of files that the server should receive, it should be 3 times the number of GPUs that are
    # supposed to be run.
    s = socket.socket()
    s.connect((host, port))
    s.send(str(number_of_files))
    s.close()

    s = socket.socket()
    s.connect((host, port))
    delimiter = ' '
    print(number_of_files)
    print(directory_list)
    print(filename_list)
    for directory in directory_list:
        print(directory)
        s.send(directory + delimiter)
    s.close()

    for i, filename in enumerate(filename_list):
        s = socket.socket()
        s.connect((host, port))

        sendFile(s, filename)
        print('File ' + str(i + 1) + ' sent')

    print('++++++++++++++++++++++WAITING FOR SERVER++++++++++++++++++++++')

    s = socket.socket()
    s.connect((host, port))
    data_server = retrFilenamesnames(s)
    s.close()

    edges_filenames = []
    error = []
    swap = True
    for s in data_server:
        print(s)
        if swap:
            error.append(float(s))
            swap = False
        else:
            edges_filenames.append(s)
            swap = True


    for i in range(int(number_of_files/3)):
        s = socket.socket()
        s.connect((host, port))
        retrFile(s)
    print(error)
    print(edges_filenames)

    return error, edges_filenames



if __name__ == '__main__':
    directory_list = ['small_cryo2_edge41_minus1', 'small_cryo2_edge41_plus1', 'smallcryopointer2DNA',
                     'smallcryopointer3DNA']

    filename_list = ['small_cryo2_edge41_minus1.conf', 'small_cryo2_edge41_minus1end_bases.txt',
                     'small_cryo2_edge41_minus1.top', 'small_cryo2_edge41_plus1.conf',
                     'small_cryo2_edge41_plus1end_bases.txt', 'small_cryo2_edge41_plus1.top',
                     'smallcryopointer2DNA.conf', 'smallcryopointer2DNAend_bases.txt', 'smallcryopointer2DNA.top',
                     'smallcryopointer3DNA.conf', 'smallcryopointer3DNAend_bases.txt', 'smallcryopointer3DNA.top']

    #filename_list = ['small_cryo2_edge41_minus1']
    number_of_files = 3
    error, edges_filenames = main(number_of_files, directory_list[:int(number_of_files/3)], filename_list[:number_of_files], False)