#   InputFile.py
#       created on: 8 March 2017
#
#           Author: Andreas Gadin

import sys
import os

class MakeInputFiles:
    @staticmethod
    def readTemplateInputFile(filename):
        path = sys.argv[0]
        #element_in_string = path.find('InputFile.py')
        element_in_string = path.find('ServerMain.py')# <------------------------------------- Uncomment when calling the full program.
        path = path[:element_in_string]
        filename = path + 'template_files/' + filename
        f = open(filename, 'r')
        lines = f.readlines()
        f.close()
        return lines

    @staticmethod
    def writeInputFile(lines, filename, input_type,  mod_dict):
        path = os.getcwd() + '/' + filename + '/input/'
        f = open(path + '/input_' + input_type, 'w')
        for line in lines:
            if line in mod_dict: # checks if the line exists as a key in the dictionary
                f.write(mod_dict[line])
            else:
                f.write(line)

        f.close()

    # The dictionary of what
    @staticmethod
    def getModDict(filename, device_nr):
        mod_dict = {'topology\n': 'topology = ' + os.getcwd() + '/' + filename + '/input/' + filename + '.top\n',
                    'energy\n': 'energy_file = ' + os.getcwd() + '/' + filename + '/output/' + 'energy' + '.dat\n',

                    'configuration_min\n': 'conf_file = ' + os.getcwd() + '/' + filename + '/input/' + filename + '.conf\n',
                    'last_conf_min\n': 'lastconf_file = ' + os.getcwd() + '/' + filename + '/output/' + 'min' + '.conf\n',
                    'trajectory_file_min\n': 'trajectory_file = ' + os.getcwd() + '/' + filename + '/output/' + 'min_traj' + '.dat\n',

                    'configuration_relax\n': 'conf_file = ' + os.getcwd() + '/' + filename + '/output/' + 'min' + '.conf\n',
                    'last_conf_relax\n': 'lastconf_file = ' + os.getcwd() + '/' + filename + '/output/' + 'relax' + '.conf\n',
                    'trajectory_file_relax\n': 'trajectory_file = ' + os.getcwd() + '/' + filename + '/output/' + 'relax_traj' + '.dat\n',

                    'configuration_go\n': 'conf_file = ' + os.getcwd() + '/' + filename + '/output/' + 'relax' + '.conf\n',
                    'last_conf_go\n': 'lastconf_file = ' + os.getcwd() + '/' + filename + '/output/' + 'sim' + '.conf\n',
                    'trajectory_file_go\n': 'trajectory_file = ' + os.getcwd() + '/' + filename + '/output/' + 'sim_traj' + '.dat\n',

                    'cuda_device\n': 'CUDA_device = ' + str(device_nr) + '\n',
                    }
        return mod_dict

    @staticmethod
    def main(filename, device_nr):
        mod_dict = MakeInputFiles.getModDict(filename, device_nr)
        lines = MakeInputFiles.readTemplateInputFile('input_min')
        MakeInputFiles.writeInputFile(lines, filename, 'min', mod_dict)

        lines = MakeInputFiles.readTemplateInputFile('input_relax')
        MakeInputFiles.writeInputFile(lines, filename, 'relax', mod_dict)
        lines = MakeInputFiles.readTemplateInputFile('input_go')
        MakeInputFiles.writeInputFile(lines, filename, 'go', mod_dict)


if __name__ == '__main__':
    filename = 'generic'
    device_nr = 0
    MakeInputFiles.main(filename, device_nr)