import subprocess
import pickle
import itertools
import sys
import maya.utils as utils
import time
import os
import random





##Users
path = 'C:/Users/biomatadm.MBB-BM-D-BOXEN/Documents/oxDNAiter_internal' #location of other python files from us

maya_package_path = 'C:/Users/biomatadm.MBB-BM-D-BOXEN/Documents/oxDNAiter_internal/maya_python_packages'# maya need special versions of numpy and scipy

path_maya  = 'C:/Users/biomatadm.MBB-BM-D-BOXEN/Documents/maya/projects/oxDNAitertest19/scenes'

error_log_file_name = 'error_log_file.txt'# log file of simulation errors

edge_filename_name = 'edges_filenames.txt'# log file of edge filenames

modified_edges_log = 'mod_edge_log.txt' #Log file of what edges are modified in each iteration

sys.path.append(path)
sys.path.append(maya_package_path)


from BSCORfunctions_2 import new_random_structure
import make_ma
import Modify_rpoly
import evaluate_edges
import converter_experimental

errors = [0,0]
edges_filenames = [0,0]

scaling_value = 1.5

nr_of_normal_edges = 190 # The number of helices normally present in a structure when it has no internal helices,
nr_of_internal = 13
best_list_of_internal = [[133, 144], [124, 134], [117, 129], [105, 111], [96, 99], [74, 79], [68, 64], [55, 60], [48, 39], [15, 28], [10, 24], [160, 21], [159, 118]]#list of internal edges in the start file, or in the best file in an iteration

total_log_path = 'C:/Users/biomatadm.MBB-BM-D-BOXEN/Documents/maya/projects/oxDNAitertest19/scenes/overall_log_file.txt'

iteration_nr = 1 #startin value
nr_of_GPUS = 8

original_ply = '13divisions.ply'




if not os.path.isfile(path_maya +'/'+ modified_edges_log):# if the simulation is started for the first time, create a blocked edges file and write some dummy edges into it.
    mod_log_file = open(path_maya +'/'+ modified_edges_log, 'a')
    mod_log_file.write('9991,9992,9993,9994'+'\n')
    mod_log_file.write('9995,9996,9997,9998'+'\n')
    mod_log_file.close()





# make_ma.make_MA(path, best_file)
# converter_experimental.export_oxDNA(path_maya+'/'+str(j[:-6])+'.ma')
#
# errors[t_nr], edges_flienames[i] = ClientMain.main(number_of_files, directory_list[:int(number_of_files / 3)], filename_list[:number_of_files], host)
error_list = ['1.0']#just needed for emailing in the first iteration

while True:
    print 'running ITERATION: '+str(iteration_nr)

    # blocked_edges = [] # blocked edges keeps track of what edges where modified in the last 2 iterations and prevents them from being modified again.
    # mod_log_file = open(path_maya +'/'+ modified_edges_log, 'r')
    #
    # edge_line_1 = mod_log_file.readlines()[-1].split(',')#read the two last lines in the mod_log_file to get the last edges modified in the last two iterations.
    # edge_line_2 = mod_log_file.readlines()[-2].split(',')
    #
    # mod_log_file.close()
    #
    # for i in edge_line_1: blocked_edges.append(int(i))
    # for i in edge_line_2: blocked_edges.append(int(i))
    #

    if iteration_nr > 1: # Analyse last iteration to find what structure performed the best
        error_log_file = open(
            path_maya +'/'+ error_log_file_name, 'r')# for the old style error metric
        edge_log_file = open(
            path_maya +'/'+ edge_filename_name, 'r')
        error_line = error_log_file.readlines()[-1].split(',')
        error_list = [float(i) for i in error_line[:-1]]
        error_index = error_list.index(min(error_list))



        edge_line = edge_log_file.readlines()[-1].split(',')#names of the files from the last iteration

        edge_log_file.close()
        error_log_file.close()


        mean_error = []

        for n, i in enumerate(edge_line[:-1]):#goes through all the simulations in the latest iteration and calculates the end to end distance of the caps through the simulation and then the standard deviation of this.
            temp = evaluate_edges.score_end_to_end(i,1000,iteration_nr-1,n)
            mean_error.append(temp)#for now only use mean error

        Temperature = float(50 - iteration_nr) # For simulated annealing

        temperature_factor = 1.0/50.0 #controls the strenght of the temperature effect

        temperature_modulated_mean_error = []

        for i in mean_error:## a simple inplementation of simulated annealing where we add a random and temperature dependent factor to the scores and then make the choice from the new random scores
            new_val = i + (Temperature* temperature_factor * random.random())
            temperature_modulated_mean_error.append(new_val)



        min_error_file_index = temperature_modulated_mean_error.index(min(temperature_modulated_mean_error))# what file has the lowest mean errror (after temperature ajustment)



        mod_log_file_name = 'modifications_iteration_' + str(iteration_nr-1)# read back the modifications from the  last iteration using pickle
        mod_log_file = open(path_maya +'/'+ mod_log_file_name, 'r')
        modifications_it = pickle.load(mod_log_file)
        mod_log_file.close()


        best_list_of_internal = modifications_it[min_error_file_index] # read back the modifications made in the best structure in the las iteration








    ### start making modifications to the best file

    available_edges_for_mod = range(nr_of_internal)# this generates a list of the number of internal edges
    random.shuffle(available_edges_for_mod) # shuffle the list to generate a random order of what edges to modify in each iteration

    list_of_internal = []
    ply_filenames = []

    for n in range(nr_of_GPUS):# make as many new structures as there is GPUs
        new_filename_ply = 'iteration_' + str(iteration_nr) + '_mod_' + str(n) + '.ply'
        new_list = new_random_structure(path_maya + '/' + original_ply,path_maya + '/' + new_filename_ply,scaling_value,best_list_of_internal,available_edges_for_mod[n])# use mod_ply to make a new ply with one modification compared to the prevous best
        list_of_internal.append(new_list)
        ply_filenames.append(new_filename_ply)


    mod_log_file_name = 'modifications_iteration_' + str(iteration_nr)# save the list containing all modifications using pickle
    mod_log_file = open(path_maya +'/'+ mod_log_file_name, 'w+')
    pickle.dump(list_of_internal,mod_log_file)
    mod_log_file.close()

    ply_iterator_file_name= 'Made_ply_iteration_'+str(iteration_nr)#create an empty file for client threads to figure out that the ply cas been created
    ply_iterator_file = open(path_maya + '/' + ply_iterator_file_name,'w')
    ply_iterator_file.close()


    while not os.path.exists(path_maya+'/rpoly_done_it_'+str(iteration_nr)):# wait for client threads to run BSCOR on the ply files
        time.sleep(60)
        print('sleeping, waiting for rpoly')

    filename_list = []

    for i in ply_filenames:

        make_ma.make_MA_interal(path_maya,i[:-4]+'.rpoly',nr_of_normal_edges,nr_of_internal)#import to maya to generate a MA file

        converter_experimental.export_oxDNA(path_maya+'/'+str(i[:-4])+'.ma')
        filename_list.append(path_maya + '/' + str(i[:-4])+'.conf')
        filename_list.append(path_maya + '/' + str(i[:-4]) + '.top')
        filename_list.append(path_maya + '/' + str(i[:-4]) + 'end_bases.txt')






    ###WRITE A LOGFILE
    log_file = open(total_log_path, 'a')
    log_file.write('Iteration: '+str(iteration_nr)+'\n')
    log_file.write('Best internal edge configuration: '+ str(best_list_of_internal) + '\n')
    if iteration_nr >> 1:
        log_file.write('End-to-end error: ' + str(mean_error[min_error_file_index]) + '\n')## FIXA !
        log_file.write('Old style Error value: ' + str(error_list[min_error_file_index]) + '\n')
    log_file.write('Try the following configurations: \n')
    for i in list_of_internal:
        log_file.write(str(i)+'\n')
    log_file.close()
    # Create list of the files absolute searchpath


    # Start threads
    number_of_files = int(nr_of_GPUS * 1.5)
    threads = []
    directory_list = []
    for i in ply_filenames:
        directory_list.append(i[:-4])
        print i[:-4]
    directory_list = ','.join(directory_list)
    filename_list = ','.join(filename_list)
    print directory_list
#########################################################################################################
###################### CALL A SUBPROCESS TO SPLIT UP THE SERVER-CALL INTO 2 THREAD ######################
#########################################################################################################
    print('Calling the subprocess!')
    # cmd = 'python C:/Users/biomatadm.MBB-BM-D-BOXEN/Documents/oxDNAiter/test_pickle.py'
    # w = ''
    iterator_file_name= 'Iteration_'+str(iteration_nr)
    iterator_file = open(path_maya + '/' + iterator_file_name,'w')
    iterator_file.write(str(number_of_files))
    iterator_file.write('\n')
    iterator_file.write(directory_list)
    iterator_file.write('\n')
    iterator_file.write(filename_list)
    iterator_file.close()

    file_name = 'Done_it_' + str(iteration_nr)
    sleep_counter = 0
    while not os.path.exists(path_maya + '/' + file_name):
        time.sleep(60)
        print('sleeping '+str(sleep_counter))
        sleep_counter += 1




    iteration_nr += 1




