import numpy as np
from scipy.stats import norm
try:
    import matplotlib.pyplot as plt
except:
    pass
#import seaborn as sns


core_path = 'C:/Users/biomatadm.MBB-BM-D-BOXEN/Documents/maya/projects/oxDNAitertest19/scenes/'
def edge_evaluator_1(file,nr_of_edge):#nr_of_edges controls how many bad edges will be returned
    truncate = 500 #used to ignore data in the beginning of simulation
    edges = file_reader_edges(file)

    mean_len = []
    std_dev = []
    for edge in edges:
        temp = norm.fit(edge[truncate:])
        mean_len.append(temp[0])
        std_dev.append(temp[1])



    worst_edge_values  =  sorted(std_dev,reverse=True)[0:nr_of_edge]#find the N the highest st dev (values)

    worst_edge_index = []
    for i in worst_edge_values:
        worst_edge_index.append(std_dev.index(i))


    return worst_edge_index


def edge_evaluator_all(file,truncate):#returns all edge indices sorted by their standard-devation, worst edge first

    edges = file_reader_edges(file)

    mean_len = []
    std_dev = []
    for edge in edges:
        temp = norm.fit(edge[truncate:])
        mean_len.append(temp[0])
        std_dev.append(temp[1])



    worst_edge_values  =  sorted(std_dev,reverse=True)

    worst_edge_index = []
    for i in worst_edge_values:
        worst_edge_index.append(std_dev.index(i))


    return worst_edge_index


def score_edges(file,truncate):#This functions calculates the std dev of the len of all egdes and returns the mean and median std dev


    full_path = file
    print full_path
    edges = file_reader_edges(full_path)

    mean_len = []
    std_dev = []
    for edge in edges:
        temp = norm.fit(edge[truncate:])
        mean_len.append(temp[0])
        std_dev.append(temp[1])



    mean_error = np.mean(std_dev)
    median_error = np.median(std_dev)


    return mean_error, median_error

def find_cap_edges(iteration_nr,mod_nr):

    conf_file = 'iteration_' + str(iteration_nr) + '_mod_' + str(mod_nr) + '.conf'

    end_base_file = 'iteration_' + str(iteration_nr) + '_mod_' + str(mod_nr) + 'end_bases.txt'

    cap_1_edges = []#store the edges that constitute the caps
    cap_2_edges = []


    max_th = 97.0
    min_th = -97.0 #threshold for top and bottom cap

    test_edge = file_reader_end_bases(core_path + end_base_file)

    test_conf = file_reader_conf_file(core_path + conf_file)

    for n, i in enumerate(test_edge):
        if test_conf[i[0]][0] > max_th and test_conf[i[1]][0] > max_th:

            print 'top edge: ' +str(n+1)
            cap_1_edges.append(n+1)

        if test_conf[i[0]][0] < min_th and test_conf[i[1]][0] < min_th:
            print 'bottom edge: ' +str(n+1)
            cap_2_edges.append(n+1)

    return [cap_1_edges,cap_2_edges]


def file_reader_end_bases(path): # This function reads the base ids of the end bases from the end_base file to a list of list where index 0 is helix_1
    edges = []


    with open(path, 'r') as f:
            my_list = [line.rstrip('\n') for line in f]#split into lines that contain x-y coordinate



    for item in my_list:
        temp_list = item.split(' ')
        temp_list = [int(i) for i in temp_list[2:]]
        edges.append(temp_list)


    return edges

def file_reader_conf_file(path): # This function reads the base ids of the end bases from the end_base file to a list of list where index 0 is helix_1
    edges = []


    with open(path, 'r') as f:
            my_list = [line.rstrip('\n') for line in f]#split into lines that contain x-y coordinate



    for item in my_list[3:]:
        temp_list = item.split(' ')
        temp_list = [float(i) for i in temp_list[:3]]
        edges.append(temp_list)


    return edges

def score_end_to_end(file,truncate,iteration_nr,mod_nr):#This functions calculates the std dev of the len of all egdes and returns the mean and median std dev


    cap_edges = find_cap_edges(iteration_nr,mod_nr)

    full_path = core_path + file
    print full_path
    edges = file_reader_edges(full_path)
    cap_1 = []
    cap_2 = []
    cap_1_coords = [[],[],[]]
    cap_2_coords = [[],[],[]]
    end_to_end_distance = []

    for i in cap_edges[0]:# iterate over the edges that make cap 1 and add the coordinates of the two end bases to cap 1

        cap_1.append(edges[((i-1)*6)])
        cap_1.append(edges[((i-1)*6)+1])
        cap_1.append(edges[((i-1)*6)+2])
        cap_1.append(edges[((i-1)*6)+3])
        cap_1.append(edges[((i-1)*6)+4])
        cap_1.append(edges[((i-1)*6)+5])

    for i in cap_edges[1]:# iterate over the edges that make cap 2 and add the coordinates of the two end bases to cap 1

        cap_2.append(edges[((i-1)*6)])
        cap_2.append(edges[((i-1)*6)+1])
        cap_2.append(edges[((i-1)*6)+2])
        cap_2.append(edges[((i-1)*6)+3])
        cap_2.append(edges[((i-1)*6)+4])
        cap_2.append(edges[((i-1)*6)+5])

    for n in range(len(cap_1[0])):#Figure out the central x y z coordinates of the caps
        temp_x = []
        temp_y = []
        temp_z = []

        for j in range(0,(len(cap_1)/3),3):
            temp_x.append(cap_1[j][n]) # add all x coordinates in the frames in order to create average
            temp_y.append(cap_1[j+1][n])
            temp_z.append(cap_1[j+2][n])

        cap_1_coords[0].append(sum(temp_x) / float(len(temp_x)))
        cap_1_coords[1].append(sum(temp_y) / float(len(temp_y)))
        cap_1_coords[2].append(sum(temp_z) / float(len(temp_z)))

    for n in range(len(cap_2[0])):
        temp_x = []
        temp_y = []
        temp_z = []

        for j in range(0,(len(cap_2)/3), 3):
            temp_x.append(cap_2[j][n]) # add all x coordinates in the frames in order to create average
            temp_y.append(cap_2[j+1][n])
            temp_z.append(cap_2[j+2][n])

        cap_2_coords[0].append(sum(temp_x) / float(len(temp_x)))
        cap_2_coords[1].append(sum(temp_y) / float(len(temp_y)))
        cap_2_coords[2].append(sum(temp_z) / float(len(temp_z)))

    # cap_coords_xyz=open(file+'capcoords'+'.xyz', 'w+')
    #
    # for n in range(len(cap_1_coords[0])):
    #     p1 = np.array([cap_1_coords[0][n], cap_1_coords[1][n], cap_1_coords[2][n]])
    #     p2 = np.array([cap_2_coords[0][n], cap_2_coords[1][n], cap_2_coords[2][n]])
    #     com = (((p1[0]+p2[0])/2), ((p1[1]+p2[1])/2), ((p1[2]+p2[2])/2))
    #     com = np.array(com)
    #     p1_trs = p1 - com
    #     p2_trs = p2 - com
    #     p1 = str(p1)
    #     p1 = p1.strip('[]')
    #     p2 = str(p2)
    #     p2 = p2.strip('[]')
    #     p1_trs = str(p1_trs)
    #     p1_trs = p1_trs.strip('[]')
    #     p2_trs = str(p2_trs)
    #     p2_trs = p2_trs.strip('[]')
    #     cap_coords_xyz.write('2'+ '\n')
    #     cap_coords_xyz.write('\n')
    #     cap_coords_xyz.write('c' + ' ' + p1_trs + '\n')
    #     cap_coords_xyz.write('c' + ' ' + p2_trs + '\n')
    # cap_coords_xyz.close()

    for n in range(len(cap_1_coords[0])):# In every frame, calculate the distance between the two center cap points
        p1 = np.array([cap_1_coords[0][n],cap_1_coords[1][n],cap_1_coords[2][n]])
        p2 = np.array([cap_2_coords[0][n],cap_2_coords[1][n],cap_2_coords[2][n]])
        d = np.linalg.norm(p1 - p2)
        end_to_end_distance.append(d)

    points=[]
    values=[]

    log_file = open(core_path + 'distance_iteration' + str(iteration_nr) + '_mod_' + str(mod_nr) + '.txt', 'w+')# for every analysis, write a log file with all distances
    for i in end_to_end_distance:
        log_file.write(str(i)+'\n')
        # values.append(i)
        # points.append(len(points)+1)
    log_file.close()

    # plt.plot(points, values)
    # plt.title('Plot')
    # plt.ylabel('Length (nm)')
    # plt.xlabel('Simulation points')
    # plt.show()


    temp = norm.fit(end_to_end_distance[truncate:])# analyse the end to end distance of the entire rod

    std_dev = temp[1]

    return std_dev


def file_reader_edges(path): # This function reads the coordinate files produced from oxDNA trajectories

    edges = []


    with open(path, 'r') as f:
            my_list = [line.rstrip('\n') for line in f]#split into lines that contain x-y coordinate



    for item in my_list:
        temp_list = item.split(' ')
        temp_list = [float(i) for i in temp_list]
        edges.append(temp_list)

    return edges


def plot_from_log(*args):

    #sns.set()

    for arg in args:

        with open(arg) as f:
            content = f.read()

        content=content.split()

        values=[]
        points=[]

        for i in content:
            values.append(i)
            points.append(len(points) + 1)

        plt.plot(points, values)

    plt.title('Plot')
    plt.ylabel('Length')
    plt.xlabel('Simulation points')
    plt.show()

if __name__ == '__main__':
    file='13divisions_3end_bases'
    score_end_to_end(file, 500)

#if __name__ == '__main__':
 #   file='square_internal_small_1_3end_bases.txtlog.txt'
  #  file_1="square_internal_small_1_3end_bases.txtlog_1.txt"
   # plot_from_log(file, file_1)
