import signal, sys, time

def rout_mod(filename,scaling): # for performing the BSCOR pipeline through maya, lets hope it works
    import subprocess
    p = subprocess.Popen('ply_to_dimacs '+filename+'.ply '+filename + '.dimacs')
    p.wait()

    p = subprocess.Popen('ply_to_embedding.exe '+filename+'.ply '+filename + '.vcode')
    p.wait()

    p = subprocess.Popen('postman_tour '+filename+'.dimacs '+filename + 'multi.dimacs')
    p.wait()

    p = subprocess.Popen('make_embedding_eulerian.exe '+filename+'.vcode '+filename + 'multi.dimacs')
    p.wait()

    p = subprocess.Popen('Atrail_search '+filename+'.ecode')
    p.wait()

    p = subprocess.Popen('Atrail_verify '+filename+'.ecode ' + filename + '.trail')
    p.wait()

    p = subprocess.Popen('scaffold-routing-rectification --input='+filename+ '.ply --output=' +filename + '.rpoly --scaling='+str(scaling))
    p.wait()

    return

def signal_handler(signal, frame):
    print 'Ctrl+C received in demo.py'
    time.sleep(1)
    sys.exit(0)



if __name__ == '__main__':


    signal.signal(signal.SIGINT, signal_handler)
    print 'demo.py started'
    #signal.pause() # does not work under Windows
    filename = sys.argv[1]
    rout_mod(filename,1.5)
    while(True):
        time.sleep(1)
